function [M, DL] = model_params3DOF_Ldamp(x)
%% Model parameters
% Model: M*nu_dot + DL*nu = tau

m = 8.6; %weight in air
Iz = 92502.96*10^(-6);  % [kgm^2]

MRB_sim = [m     0    0;  
           0     m    0;
           0     0    Iz];

% Added mass
MA_sim = diag([5.0899 19.4 0.16]);

% Linear damping
Xu = -x(1);
Yv = -x(2);
Yr = -x(3);
Nv = -x(3);
Nr = -x(4);

DL = [ -Xu    0.0  0.0; 
        0.0  -Yv  -Yr; 
        0.0  -Nv  -Nr]; 

% Total mass matrix
M = MA_sim + MRB_sim;


end

