%% Run simulation again to see plots:
figure(2); clf; title('Position error'); hold on;
figure(3); clf; title('Heading error'); hold on; 
figure(4); clf; title('Bias'); hold on;
figure(5); clf; title('Velocity estimates'); hold on; 
figure(6); clf; title('Position estimates'); hold on; 

%c1 = rand(1,3);
c1 = 'r';
test_title = {'surge-sway', 'surge','surge-yaw', 'sway', 'sway-yaw', 'yaw'};
for ii = 1:nr_tests
    eta_data = eta_meas_vec{ii}';
    nu_data  = nu_data_vec{ii}(2:4,:);
    nu_time  = nu_data_vec{ii}(1,:);
    [eta_est,nu_est,etadot_est,b_est,time_vec,tau_data] = sim3DOFdiscrete_obs(x_opt, eta_data, nu_data, drone_table_vec{ii}, samp_time);
    len_est = length(nu_est);

    x_err    = eta_data(1,1:len_est)-eta_est(1,1:len_est);
    y_err    = eta_data(2,1:len_est)-eta_est(2,1:len_est);
    pos_err_norm = sqrt(x_err.^2+y_err.^2);
    psi_err = rad2radpi(eta_data(3,1:len_est)-eta_est(3,1:len_est));
    psi_err_abs = abs(psi_err);
%         b_est_abs   = abs(b_est);
    figure(2); subplot(2,3,ii); plot(time_vec,pos_err_norm,'color',c1);title(test_title{ii}), xlabel('Time (s)'); ylabel('m'); grid on; 
    figure(3); subplot(2,3,ii); plot(time_vec, psi_err/deg2rad,'color',c1); title(test_title{ii}), xlabel('Time (s)'); ylabel('deg'); grid on;
    figure(4); subplot(2,3,ii); plot(time_vec,b_est,'color',c1);title(test_title{ii}), xlabel('Time (s)'); ylabel('N'); grid on; 

    eta_dot = eta_dot_data{ii}(2:end,:);
    
    figure(5);  % Pose
    subplot(3,1,1); plot(time_vec,eta_est(1,:),'-',time_vec,eta_data(1,1:len_est),'-.','color',c1); ylabel('x (m)'); grid on; title('Pose');
    subplot(3,1,2); plot(time_vec,eta_est(2,:),'-',time_vec,eta_data(2,1:len_est),'-.','color',c1); ylabel('y (m)'); grid on;
    subplot(3,1,3); plot(time_vec,eta_est(3,:)/deg2rad,'-',time_vec,eta_data(3,1:len_est)/deg2rad,'-.','color',c1); ylabel('\psi (deg)'); grid on; 
    figure(6);  % Velocities
    subplot(3,1,1); plot(time_vec,nu_est(1,:),'-',nu_time,nu_data(1,:),'-.','color',c1); ylabel('u (m/s)'); grid on; title('Velocities');
    subplot(3,1,2); plot(time_vec,nu_est(2,:),'-',nu_time,nu_data(2,:),'-.','color',c1); ylabel('v (m/s)'); grid on;
    subplot(3,1,3); plot(time_vec,nu_est(3,:)/deg2rad,'-',nu_time,nu_data(3,:)/deg2rad,'-.','color',c1); ylabel('r (deg/s)'); grid on; 
    figure(7);  % Tau
    subplot(3,1,1); plot(time_vec,tau_data(1,1:len_est),'-','color',c1); ylabel('X (N)'); grid on; title('Tau');
    subplot(3,1,2); plot(time_vec,tau_data(2,1:len_est),'-','color',c1); ylabel('Y (N)'); grid on;
    subplot(3,1,3); plot(time_vec,tau_data(3,1:len_est),'-','color',c1); ylabel('N (Nm)'); grid on; 
    pause;
end
figure(2); hold off; title('Position error');
figure(3); hold off; title('Heading error');
figure(4); hold off; title('Bias magnitude');
figure(5); hold off; xlabel('Time (s)'); %title('Velocity estimates'); 
figure(6); hold off; xlabel('Time (s)'); %title('Pose estimates'); 
