function [history, x, fval] = runfminsearch_obs(x0, eta_meas_vec, nu_data_vec, drone_table_vec, ...
    samp_time,nr_tests, options, LB, UB)

history.x = [];
history.fval = [];

options = optimset(options, 'OutputFcn', @outfun);
% Bounded fminsearch: 
[x,fval,exitflag,output] = fminsearchbnd(@(x)KPI3_sim(x, eta_meas_vec, nu_data_vec, ...
                drone_table_vec, samp_time, nr_tests), x0, LB , UB, options);

% Unbounded:
% [x, fval] = fminsearch(@(x)KPI(x, eta_meas, drone_table, samp_time),x0,...
%             options);

%Nested function to save from each iteration
function stop = outfun(x,optimvalues,state)
        stop = false;
        if isequal(state,'iter')
            history.fval = [history.fval; optimvalues.fval];
            history.x = [history.x; x];
        end
end           
end