#!/usr/bin/env python
import rospy
from p2_drone.msg import ControlForce, StateEstimate
from geometry_msgs.msg import Vector3

class DroneMeas:
    def __init__(self):
        self.control_force = ControlForce()     
        self.state_estimate = StateEstimate()
        self.attitude = Vector3()

        # Subscribers:
        rospy.Subscriber("/controller/control_force", ControlForce, self.cb_controller)
        rospy.Subscriber("/observer/state_estimate", StateEstimate, self.cb_state_estimate)
        rospy.Subscriber("/observer/attitude", Vector3, self.cb_attitude)

    def cb_controller(self, msg):
        self.control_force = msg

    def cb_state_estimate(self, msg):
        self.state_estimate = msg
    
    def cb_attitude(self,msg):
        self.attitude = msg