import numpy as np
import config
import math
#General finite-difference Jacobian
#Both fun and x are assumed vector valued
def jacobianFD(x,dx):
    f = fun(x)
    m = x.size
    n = f.size
    jacMatrix = np.zeros((n,m))
    for k in range(x.size):
        xPerturbed = np.copy(x)
        xPerturbed[k] = xPerturbed[k] + dx
        fPerturbed = fun(xPerturbed)
        jacMatrix[:,k] = (fPerturbed-f)/dx
    return jacMatrix

def fun(x):
    trans_matrix = np.eye(3) #J(psi)
    trans_matrix[0:2,0:2] = np.array([[math.cos(x[2]), -math.sin(x[2])],\
             [math.sin(x[2]), math.cos(x[2])]])
    A = np.zeros((9,9), float)
    A[0:3,3:6] = trans_matrix
    A[3:6,3:6] = -np.matmul(np.linalg.inv(config.mass_total),\
        (get_damping(x) + get_coriolis(x)))
    A[3:6,6:9] = np.linalg.inv(config.mass_total)
    return np.matmul(A,x)

def get_damping(x):
        quadratic_damping = np.zeros((3,3), float)
        damping_total = np.zeros((3,3), float)
        quadratic_damping = np.matmul(config.quadratic_damping, abs(x[3:6]))
        damping_total = config.linear_damping_case2 + quadratic_damping 
        return damping_total

def get_coriolis(x):
        coriolis_centr = np.zeros((3,3), float)
        coriolis_centr[0,2] = config.coriolis_centr[0,2]*x[4]
        coriolis_centr[1,2] = config.coriolis_centr[1,2]*x[3]
        coriolis_centr[2,0] = config.coriolis_centr[2,0]*x[4]
        coriolis_centr[2,1] = config.coriolis_centr[2,1]*x[3]
        return coriolis_centr

